PImage img;
int heartrate;
import processing.serial.*;
Serial arduinoKommunikation;
String payload;
String[] liste;


void setup() {
  String portName = Serial.list()[0];
  arduinoKommunikation = new Serial(this, portName, 9600);

  size(1000, 500);
  frameRate(20);
  img = loadImage("biofeedback.png");
  image(img, 0, 0);
  loadPixels();
}

void draw() {
  if ( arduinoKommunikation.available() > 0) {
    payload = arduinoKommunikation.readStringUntil('\n');
    if (payload != null) {
      heartrate = parseInt(payload.trim());
      println(heartrate);
    }
  }

  float percentage = -0.7/40*heartrate + 2.15;
  for (int x = 0; x < img.width; x++) {
    for (int y = 0; y < img.height; y++ ) {
      int loc = x + y*img.width;
      float r, g, b;
      r = red (img.pixels[loc]);
      g = green (img.pixels[loc]);
      b = blue (img.pixels[loc]);
      float adjustbrightness = 64 - 64*percentage;
      float cont = percentage;
      r = r*cont - adjustbrightness;
      g = g*cont - adjustbrightness;
      b = b*cont - adjustbrightness;
      r = constrain(r, 0, 255);
      g = constrain(g, 0, 255);
      b = constrain(b, 0, 255);
      color c = color(r, g, b);
      pixels[y*width + x] = c;
    }
  }
  updatePixels();
}
