//Myosensor bitte an A0 anschließen
//OLED an einen der vier I2C Ports anschliessen.

#include <SeeedOLED.h>
#include <Wire.h>
#include <SoftwareSerial.h>
SoftwareSerial Serial_89(8, 9);

int max_analog_dta      = 300;// max analog data
int min_analog_dta      = 100;// min analog data
int static_analog_dta   = 0;  // static analog data
int level = 5;

int getAnalog(int pin) {
  long sum = 0;
  for (int i = 0; i < 32; i++) {
    sum += analogRead(pin);
  }
  Serial.println(sum);
  Serial_89.println(sum);
  int dta = sum >> 5;
  max_analog_dta = dta > max_analog_dta ? dta : max_analog_dta;
  min_analog_dta = min_analog_dta > dta ? dta : min_analog_dta;
  return sum >> 5;
}

void setup() {
  Wire.begin();
  Serial.begin(9600);
  Serial_89.begin(9600);
  SeeedOled.init();
  SeeedOled.clearDisplay();
  SeeedOled.setNormalDisplay();
  SeeedOled.setPageMode();
  SeeedOled.setTextXY(1, 0);
  SeeedOled.putString("EMG prototype");
  long sum = 0;

  for (int i = 0; i <= 10; i++) {
    for (int j = 0; j < 100; j++) {
      sum += getAnalog(A0);
      delay(1);
    }
  }
  sum = sum / 1100;
  static_analog_dta = sum;
  Serial.print("static_analog_dta = ");
  Serial.println(static_analog_dta);
}

void loop() {
  int val = getAnalog(A0);
  int level2;
  if (val > static_analog_dta)  {
    level = 5 + map(val, static_analog_dta, max_analog_dta, 0, 10);
  } else {
    level = 5 - map(val, min_analog_dta, static_analog_dta, 0, 10);
  }
  for (int i = 0; i < 10; i++) {
    SeeedOled.setTextXY(1, i);
    SeeedOled.putChar(32);
  }
  for (int i = 0; i < level - 5; i++) {
    SeeedOled.setTextXY(1, i);
    SeeedOled.putChar(124);
  }
  delay(20);
}
